﻿package
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import com.neatfilm.graphics.fractal.Koch;


	public class Brancher extends Sprite
	{
		private var rot:Number;
		private var theta:Number=0;
		private var stack:Array = new Array();
		private var i:Number;
		private var centerX:Number;
		private var centerY:Number;
		var w:Number = 600;
		var h:Number = 600;
		var rNumber:Number;
		
		public function Brancher()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		private function clickHandler(e:MouseEvent):void
		{
			centerX = e.stageX;
			centerY = e.stageY;
			theta= Math.random()*360;
			rNumber = Math.random()*5;
			i=0;
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			rot=-30*Math.sin(Math.PI / 180 * theta);
			theta+=0.2;
			if(i<80){
				
				var koch:Koch = new Koch(i*4,i*4, rNumber, 0xFFFFFF);
				koch.x=centerX+Math.cos(rot)*i*3;
				koch.y=centerY-Math.sin(rot)*i*3;
				addChild(koch);

				/*stack[i] = new Sprite();
				stack[i].graphics.beginFill(0x000000,1);
				stack[i].graphics.lineStyle(.2,0xff0000,1);
				stack[i].graphics.drawCircle(0,0,20);
				stack[i].x = centerX+Math.cos(rot)*i*3;
				stack[i].y = centerY-Math.sin(rot)*i*3;
				stack[i].scaleX =1-i/150;
				stack[i].scaleY =1-i/150;
				addChild(stack[i]);*/
				i++;
			}else{
				removeEventListener(Event.ENTER_FRAME,enterHandler);
			}
		}
	}
}